"""
  CS 141/218, UC Riverside

  Compute nearest pair of points using two algorithms
  First algorithm is 'brute force' comparison of every possible pair
  Second, 'divide and conquer'
  
  Adapted from some code I found on-line, cannot find the author anymore

"""
 
from random import randint, randrange
from operator import itemgetter, attrgetter
 
infinity = float('inf')
 
# we use of complex numbers to represent 2D points making distance == abs(P1-P2)
 
def bruteForceClosestPair(point):
    numPoints = len(point)
    if numPoints < 2:
        return infinity, (None, None)
    return min( ((abs(point[i] - point[j]), (point[i], point[j]))
                 for i in range(numPoints-1)
                 for j in range(i+1,numPoints)),
                 key=itemgetter(0))
 
def closestPair(point):
    xP = sorted(point, key= attrgetter('real'))
    yP = sorted(point, key= attrgetter('imag'))
    return _closestPair(xP, yP)
 
def _closestPair(xP, yP):
    n = len(xP)
    if n <= 3:
        return bruteForceClosestPair(xP)
    Xl = xP[:n/2] 
    Xr = xP[n/2:]
    Yl, Yr = [], []
    median = Xl[-1].real
    for p in yP:
        if p.real <= median:
            Yl.append(p)
        else:
            Yr.append(p)
    dl, pairl = _closestPair(Xl, Yl) 
    dr, pairr = _closestPair(Xr, Yr)
    dm, pairm = (dl, pairl) if dl < dr else (dr, pairr)
    strip = [p for p in yP if abs(p.real - median) < dm] # Points within dm of median sorted by Y coord
    n_strip = len(strip)
    closestY = (dm, pairm)
    if n_strip > 1:
        # There is a proof that you only need compare a max of 7 next points
        for i in range(n_strip-1):
            for j in range(i+1,min(i+8, n_strip)):
                if abs(strip[i] - strip[j]) < closestY[0]:
                    closestY = (abs(strip[i] - strip[j]), (strip[i], strip[j]))
    return closestY

if __name__ == '__main__':
    pointList = [randint(0,1000)+1j*randint(0,1000) for i in range(100)]
    print 'input = ', pointList
    print '  bruteForceClosestPair:', bruteForceClosestPair(pointList)
    print '            closestPair:', closestPair(pointList)
