"""
  CS 141/218, UC Riverside

  Fractional Knapsack (greedy)

"""

from operator import itemgetter, attrgetter

def itemSize(item): return item[0]
def itemValue(item): return item[1]
def itemName(item): return item[2]

def fractional_knapsack(S, W):
    """
    given a set of items S, each described by a
    triple (benefit, weight, id) and the size of the knapsack W
    returns the largest subset of S to fit in the knapsack
    """
    v = []
    for item in S:
        value = float(item[1]) / float(item[0])
        v.append((value,item[1],item[2]))
    v.sort(key=itemgetter(0))
    w, result = 0, []
    while w < W:
        high = v[-1] # highest value
        v.pop()
        a = min(high[1], W-w)      # take as much of high as possible
        w += a                     #update the available space in the knapsack
        result.append((a,high[2])) # remember which item and how much we took
    return result

if __name__ == '__main__':
    items = [(3,3,'A'),
             (4,1,'B'),
             (8,3,'C'),
             (10,4,'D'),
             (15,3,'E'),
             (20,6,'F')]
    print 'items (b,w,i) = ', items, ' knapsack = ', 12
    print fractional_knapsack(items,12)
    
