"""
   CS 141/218
   Huffman coding
"""

# Copyright (c) 2011 the authors listed at the following URL, and/or
# the authors of referenced articles or incorporated external code:
# http://en.literateprograms.org/Huffman_coding_(Python)?oldid=15672

import heapq

def makeHuffTree(t):
   heapq.heapify(t) # Transform list t into a heap, in-place, in linear time
   while len(t) > 1:
      childR, childL = heapq.heappop(t), heapq.heappop(t)
      parent = (childL[0] + childR[0], childL, childR)
      heapq.heappush(t, parent)
#     print "new heap ->", len(t), t
   return t[0] # root node

def printHuffTree(huffTree, prefix = ''):
   if len(huffTree) == 2:
      print huffTree[1], prefix
   else:
      printHuffTree(huffTree[1], prefix + '0')
      printHuffTree(huffTree[2], prefix + '1')

exampleData = [
  (1241670 , 'e'),   
  ( 969225 , 't'),   
  ( 820011 , 'a'),   
  ( 768052 , 'i'),   
  ( 764055 , 'n'),   
  ( 714095 , 'o'),   
  ( 706768 , 's'),   
  ( 668132 , 'r'),   
  ( 448308 , 'l'),   
  ( 363709 , 'd'),   
  ( 350386 , 'h'),   
  ( 344391 , 'c'),   
  ( 287770 , 'u'),   
  ( 281775 , 'm'),   
  ( 235145 , 'f'),   
  ( 203171 , 'p'),   
  ( 189182 , 'y'),   
  ( 181188 , 'g'),   
  ( 135225 , 'w'),   
  ( 124567 , 'v'),   
  ( 106581 , 'b'),   
  (  39301 , 'k'),   
  (  21982 , 'x'),   
  (  19984 , 'j'),   
  (   9325 , 'q'),   
  (   5990 , 'z')   
]


if __name__ == '__main__':
   huffTree = makeHuffTree(exampleData)
   printHuffTree(huffTree)

