"""
  CS 141/218, UC Riverside
  
  01 knapsack recursive, and dynamic programming

"""

# each item to be packed is represented as a set of triples (size,value,name)

def we(item): return item[0]
def be(item): return item[1]
def na(item): return item[2]

def knapsack1(i,k,items):
    """
    purely recursive computation of P[i,k]
    """
    n = len(items)
    if i == n:
        return be(items[n-1]) if we(items[n-1]) <= k else 0
    # i must be < n
    if we(items[i-1]) > k:
        return knapsack1(i+1,k,items)
    else:
	return max(knapsack1(i+1,k,items),
                   be(items[i-1]) + knapsack1(i+1,k-we(items[i-1]),items))

def knapsack2(w,items):
    """
    dynamic programming computation of P[n,k]
    returns the dyn programming table in the form of a dictionary
    """
    P = {}
    n = len(items)
    for j in range(w+1):
        P[n,j] = be(items[n-1]) if we(items[n-1]) <= j else 0
    for i in range(len(items)-1,0,-1):
	for j in range(w+1):
            if we(items[i-1]) > j:
	        P[i,j] = P[i+1,j]
            else:
                P[i,j] = max(P[i+1,j], be(items[i-1])+P[i+1,j-we(items[i-1])])
    return P

def print_table(T,n,r):
    """
    prints the dynamic programming table from row n backward
    """
    for i in range(n,0,-1):
        for j in range(r+1):
            if (i,j) in T:
                print repr(T[i,j]).rjust(3),
            else:
                print '    ',
        print
    
if __name__ == '__main__':
#   Example from the lecture notes
#   items = [(2,2,'A'),
#            (2,3,'B'),
#            (6,5,'C'),
#            (5,4,'E'),
#            (4,6,'F')]
#   w = 10

#   Another example
    items = [(2,2,'A'),
             (2,3,'B'),
             (6,5,'C'),
             (5,4,'D'),
             (5,4,'E'),
             (3,6,'F'),
             (5,4,'G'),
             (4,6,'H'),
             (2,4,'I'),
             (4,6,'J')]
    w = 16

    # prints the dynamic programming table calling the recursive
    # function for each entry

    for i in range(len(items),0,-1):
        for k in range(w+1):
            print repr(knapsack1(i,k,items)).rjust(3),
        print
    print

    # computes and print the dynamic programming table
    
    T = knapsack2(w,items)
    print_table(T,len(items),w)
